{*****************************************************************************}
{*									     *}
{*			   UniPascal version 1.50			     *}
{*				unit inlines				     *}
{*									     *}
{*		   (c) 1990 Software R&D Laboratory, Sofia		     *}
{*									     *}
{*****************************************************************************}

unit inlines; interface    			            (*){*)(*$N+$E+*){*}
  (*) {*) uses UniPascal; {*}

  function  ScanFor(ch: char; (*)const{*)var{*} source;
		    offset: cardinal; lim: integer): integer;
    (*) code $5f, $13, 1; (*)

  procedure rename(old, new: string);
    (*) code $5e, $3b; (*)

  procedure remove(fname: string);
    (*) code $5e, $37; (*)

  function GetInteger(var Src;offset:word;limit:word;var EndPos:word): LongInt;
    (*) code $5f, $14, $30; (*)

  function GetReal(var Src; offset: word; limit: word; var EndPos: word): Real;
    (*) code $5f, $14, $b0; (*)

  {$ifdef Unipas}
  procedure Real2Str (R : real; W : Natural; var S : string);
  code $5f, $14, $81; { W -     }
  {$Endif}

(*) end. {*) implementation {*}

  procedure Remove(fname: string);
    var f: file;
  begin
    assign(f, fname);
    system.erase(f);
  end { remove };

  procedure Rename(old, new: string);
    var f: file;
  begin
    assign(f, old);
    system.rename(f, new);
  end { rename };

  function ScanFor(ch: char; var source; offset: word; lim: integer): integer;
    label exit;
    type ca = packed array [0..10000] of char;
    var i: integer;
	cap: ^ca;
  begin
    i:= 0; cap:= addr(ca(source)[offset]);
    if lim >= 0 then
      while i < lim do begin
	if cap^[i] = ch then goto Exit;
	Inc(i);
      end { while }
    else begin
      while i > lim do begin
	if cap^[i] = ch then goto Exit;
	Dec(i);
      end { while };
    end { if };
exit:
    ScanFor:= i;
  end { ScanFor };

  function GetInteger(var Src; offset: word; limit: word; var EndPos: word):
	    LongInt;
    type ca = packed array [0..0] of char;
    var nodigits, hex: boolean;
	radix: byte;
	num: LongInt;
	ch: char;
	cap: ^ca;
  begin
  NoDigits:= true; system.InOutRes:= 0;
  cap:= addr(ca(Src)[offset]);
  hex:= cap^[0] = '$'; radix:= 10 + ord(hex)*6;
  EndPos:= ord(hex); num:= 0;
  repeat ch:= UpCase(cap^[EndPos]);
    while ('0' <= ch) and (ch <= '9') or
	  hex and ('A' <= ch) and (ch <= 'F') do
      begin num:= num * radix - ord('0') + ord(ch);
      if 'A' <= ch then num:= num - 7;
      Inc(EndPos); ch:= UpCase(cap^[EndPos]);
      NoDigits:= false;
      end { while };
    inc(EndPos, ord(ch = '_'));
  until ch <> '_';
  GetInteger:= num;
  if NoDigits then system.InOutRes:= -1;
  end { GetInteger };

  function GetReal(var Src; offset: word; limit: word; var EndPos: word): Real;
    type ca = packed array [0..1000] of char;
    var Ipart, Fpart, Epart: LongInt;
	cap: ^ca; r: real; code: integer; s: string;
  begin
  EndPos:= 0; cap:= addr(ca(Src)[offset]); system.InOutRes:= 0;
  while (EndPos < limit) and (cap^[EndPos] in ['0'..'9', '_']) do Inc(EndPos);
  if (cap^[EndPos] = '.') and (EndPos < limit)
    then repeat Inc(EndPos)
	 until (limit <= EndPos) or not (cap^[EndPos] in ['0'..'9', '_']);
  if (upcase(cap^[EndPos]) = 'E') and (EndPos < limit)
    then begin Inc(EndPos); inc(EndPos, ord(cap^[EndPos] = '_'));
	 if ((cap^[EndPos] = '+') or (cap^[EndPos] = '-')) and
	    (EndPos < limit)
	   then Inc(EndPos);
	 while (EndPos < limit) and (cap^[EndPos] in ['0'..'9', '_']) do
	   Inc(EndPos);
	 end;
  if EndPos = 0 then exit;
  s[0]:= chr(EndPos); Move(cap^, s[1], EndPos);
  while pos('_', s) <> 0 do delete(s, pos('_', s), 1);
  Val(s, r, code);
  if code <> 0 then system.InOutRes:= -1;
  getreal:= r;
  end { GetReal };

end { inlines }.
